unit FBuff;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, DialSpinEdit, StdCtrls, CChara, CheckLst;

type
	TBuffForm = class(TForm)
		Label1: TLabel;
		Label2: TLabel;
		GroupBox1: TGroupBox;
		CheckBox1: TCheckBox;
		DSE1: TDialSpinEdit;
		Label3: TLabel;
		Label4: TLabel;
    DSE2: TDialSpinEdit;
		Label5: TLabel;
    DSE3: TDialSpinEdit;
		Button1: TButton;
		Button2: TButton;
    Edit1: TEdit;
    CheckListBox1: TCheckListBox;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
		procedure CheckBox1Click(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
	private
		{ Private 錾 }
		FData : TTRPGBuff;
    procedure SetData(const Value: TTRPGBuff);
    function GetDefTags: TStrings;
    procedure SetDefTags(const Value: TStrings);
	public
		{ Public 錾 }
		function Execute : Boolean;
		property Data : TTRPGBuff read FData write SetData;
		property DefaultTags : TStrings read GetDefTags write SetDefTags;
	end;

var
	BuffForm: TBuffForm;

implementation

{$R *.dfm}

procedure TBuffForm.CheckBox1Click(Sender: TObject);
begin
	DSE1.Visible := not CheckBox1.Checked;
	Label3.Visible := DSE1.Visible;
end;

function TBuffForm.Execute: Boolean;
var
	I : Integer;
	SL : TStringList;
  LC: Integer;
begin
	Edit1.Text := FData.Name;
	Memo1.Lines.Text := FData.Tags.Text;
	CheckBox1.Checked := FData.Left <= 0;
	DSE1.Value := FData.Left;
	CheckBox1Click(Self);

	DSE2.Value := FData.EffectDices;
	DSE3.Value := FData.EffectVal;

	Memo1Change(Self);
	SL := TStringList.Create;
	SL.Sorted := True;
	SL.Duplicates := dupIgnore;
	SL.AddStrings(CheckListBox1.Items);
	CheckListBox1.Items := SL;
	SL.Free;

	Result := ShowModal = MrOk;

	FData.Name := Edit1.Text;
	FData.Tags := Memo1.Lines;
	for LC := 0 to CheckListBox1.Items.Count - 1 do begin
		if CheckListBox1.Checked[LC] then
			FData.Tags.Add(CheckListBox1.Items[LC]);
	end;

	I := FData.Tags.IndexOf('');
	if I >= 0 then FData.Tags.Delete(I);

	if CheckBox1.Checked then begin
		FData.Left := 0;
	end else FData.Left := DSE1.Value;

	FData.EffectDices := DSE2.Value;
	FData.EffectVal   := DSE3.Value;
	if FData.Tags.Text = '' then Result := False;
end;

procedure TBuffForm.FormCreate(Sender: TObject);
begin
	FData := TTRPGBuff.Create;
	FData.Left := 18;
end;

procedure TBuffForm.FormDestroy(Sender: TObject);
begin
	FData.Free;
end;

function TBuffForm.GetDefTags: TStrings;
begin
	Result := CheckListBox1.Items;
end;

procedure TBuffForm.Memo1Change(Sender: TObject);
var
  LC: Integer;
begin
	Button1.Enabled := trim(Memo1.Text) <> '';
	if not Button1.Enabled then begin
		for LC := 0 to CheckListBox1.Items.Count - 1 do
			if CheckListBox1.Checked[LC] then begin
				Button1.Enabled := True;
				Exit;
			end;
	end;
end;

procedure TBuffForm.SetData(const Value: TTRPGBuff);
begin
	if Assigned(Value) then FData.Assign(Value) else begin
		FData.Free;
		FData := TTRPGBuff.Create;
		FData.Left := 18;
	end;
end;

procedure TBuffForm.SetDefTags(const Value: TStrings);
begin
	if Assigned(Value) then CheckListBox1.Items.Assign(Value)
	else CheckListBox1.Items.Clear;
end;

end.
