unit FChara;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, DialSpinEdit, Grids, ValEdit, ExtCtrls, ComCtrls, Menus,
	CChara, FindUnit;

type
	TCharactorForm = class(TForm)
		PageControl1: TPageControl;
		TabSheet1: TTabSheet;
		TabSheet2: TTabSheet;
		Label2: TLabel;
		Label3: TLabel;
		Label4: TLabel;
		Label5: TLabel;
		Label6: TLabel;
		Label7: TLabel;
		Edit1: TEdit;
		DSE1: TDialSpinEdit;
		DSE2: TDialSpinEdit;
		DSE3: TDialSpinEdit;
		DSE4: TDialSpinEdit;
		DSE5: TDialSpinEdit;
		DSE6: TDialSpinEdit;
		DSE7: TDialSpinEdit;
		DSE8: TDialSpinEdit;
		Label1: TLabel;
		Edit2: TEdit;
		ComboBox1: TComboBox;
		Edit3: TEdit;
		ComboBox2: TComboBox;
		Edit4: TEdit;
		ComboBox3: TComboBox;
		Edit5: TEdit;
		ComboBox4: TComboBox;
		GroupBox2: TGroupBox;
		Memo1: TMemo;
		Panel1: TPanel;
		Button1: TButton;
		Button2: TButton;
		Label8: TLabel;
		ComboBox5: TComboBox;
		Button3: TButton;
		TabControl1: TTabControl;
		ListView1: TListView;
		RichEdit1: TRichEdit;
		Label9: TLabel;
		Label10: TLabel;
		Label11: TLabel;
		Label12: TLabel;
		PopupMenu1: TPopupMenu;
		A1: TMenuItem;
		D1: TMenuItem;
		Label13: TLabel;
		Button4: TButton;
		PopupMenu2: TPopupMenu;
		C1: TMenuItem;
		ListView2: TListView;
		A2: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
		procedure ComboBox1Change(Sender: TObject);
		procedure ComboBox2Change(Sender: TObject);
		procedure ComboBox3Change(Sender: TObject);
		procedure ComboBox4Change(Sender: TObject);
		procedure DSE5Change(Sender: TObject);
		procedure DSE6Change(Sender: TObject);
		procedure DSE7Change(Sender: TObject);
		procedure DSE8Change(Sender: TObject);
		procedure TabControl1Change(Sender: TObject);
		procedure A1Click(Sender: TObject);
		procedure ListView1DblClick(Sender: TObject);
		procedure PageControl1Change(Sender: TObject);
		procedure Button3Click(Sender: TObject);
		procedure ListView2SelectItem(Sender: TObject; Item: TListItem;
			Selected: Boolean);
    procedure ListView2Edited(Sender: TObject; Item: TListItem; var S: string);
    procedure A2Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure ListView2DblClick(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
	private
		FSystem: TFileName;
		FOldLoaded : TFileName;
		FOpenName: String;
		FData : TTRPGCharactorData;
		FOnAddCharactor: TNotifyEvent;
		{ Private 錾 }
		procedure OrderChange(const ID :Integer;const DestA,DestB,DestC:TControl);
		procedure SetValueList;
		procedure LineToList;
		function GetDataPath : TFileName;

		procedure LoadFile(const FileName : String);
		procedure SaveFile(const FileName : String);

		procedure SetData(const C : TTRPGCharactorData);
	public
		{ Public 錾 }
		function Execute(const MultiMode : Boolean) : Boolean;
	published
		property System : TFileName read FSystem write FSystem;
		property OpenName : String read FOpenName write FOpenName;
		property Data : TTRPGCharactorData read FData;
		property OnAddCharactor : TNotifyEvent read FOnAddCharactor write FOnAddCharactor;
	end;

var
  CharactorForm: TCharactorForm;

implementation

uses FVariable;

{$R *.dfm}

procedure LItoValForm(const LI : TListItem);
begin
	LI.Caption := ValForm.Data.Name;
	LI.SubItems.Clear;
	LI.SubItems.Add(ValForm.Data.TagList);
	LI.SubItems.Add(ValForm.Data.Value);
end;

procedure TCharactorForm.A1Click(Sender: TObject);
begin
	if ListView1.Selected = nil then begin
		ValForm.Data.Line := '';
	end else begin
		ValForm.Data.Line := RichEdit1.Lines[ListView1.ItemIndex];
	end;

	if ValForm.Execute then begin
		ListView1.Items.BeginUpdate;
		if ListView1.Selected = nil then begin
			RichEdit1.Lines.Add(ValForm.Data.Line);
			LItoValForm(ListView1.Items.Add);
		end else begin
			RichEdit1.Lines[ListView1.ItemIndex] := ValForm.Data.Line;
			LItoValForm(ListView1.Selected);
		end;

		ListView1.Items.EndUpdate;
	end;
end;

procedure TCharactorForm.A2Click(Sender: TObject);
begin
	with ListView2.Items.Add do begin
		Caption := '';
		if not EditCaption then begin
			Delete;
		end;
	end;
end;

procedure TCharactorForm.Button1Click(Sender: TObject);
begin
	if Button1.ModalResult = mrNone then begin
		if PageControl1.Enabled = False then Exit;
		
		if Assigned(FOnAddCharactor) then begin
			if not Assigned(FData) then FData := TTRPGCharactorData.Create;
			SetData(FData);
			FOnAddCharactor(Sender);
		end;
	end;
end;

procedure TCharactorForm.Button3Click(Sender: TObject);
begin
	if ComboBox5.Text <> '' then begin
		Memo1.SelText := '{' + ComboBox5.Text + '}';
		Memo1.SetFocus;
	end;
end;

procedure TCharactorForm.Button4Click(Sender: TObject);
begin
	if FOldLoaded <> '' then begin
		LoadFile(GetDataPath + FOldLoaded + '.txt');
		PageControl1.Enabled := True;
	end;
end;

procedure TCharactorForm.C1Click(Sender: TObject);
var S : String;
begin
	if not Assigned(ListView2.Selected) then Exit;

	if FileExists(GetDataPath + ListView2.Selected.Caption + '.txt') then
		if MessageDlg(ListView2.Selected.Caption + '{ɍ폜܂H',mtCustom,[mbYes,mbNo],0) = mrYes then begin
			S := ListView2.Selected.Caption;
			FOldLoaded := '';
			ListView2.Selected.Delete;     
			DeleteFile(GetDataPath + S + '.txt'); 
		end;
end;

procedure TCharactorForm.ComboBox1Change(Sender: TObject);
begin
	OrderChange(ComboBox1.ItemIndex,DSE1,Label4,DSE5);
end;

procedure TCharactorForm.ComboBox2Change(Sender: TObject);
begin
	OrderChange(ComboBox2.ItemIndex,DSE2,Label5,DSE6);
end;

procedure TCharactorForm.ComboBox3Change(Sender: TObject);
begin
	OrderChange(ComboBox3.ItemIndex,DSE3,Label6,DSE7);
end;

procedure TCharactorForm.ComboBox4Change(Sender: TObject);
begin
	OrderChange(ComboBox4.ItemIndex,DSE4,Label7,DSE8);
end;

procedure TCharactorForm.DSE5Change(Sender: TObject);
begin
	DSE1.Value := DSE5.Value;
end;

procedure TCharactorForm.DSE6Change(Sender: TObject);
begin
	DSE2.Value := DSE6.Value;
end;

procedure TCharactorForm.DSE7Change(Sender: TObject);
begin
	DSE3.Value := DSE7.Value;
end;

procedure TCharactorForm.DSE8Change(Sender: TObject);
begin
	DSE4.Value := DSE8.Value;
end;

function TCharactorForm.Execute(const MultiMode : Boolean): Boolean;
var
	FF : TFileFind;
begin
	FF := TFileFind.Create(GetDataPath + '*.txt',faAnyFile);
	ListView2.Items.Clear;

	while FF.Finded do begin
		with ListView2.Items.Add do begin
			Caption := ChangeFileExt(FF.Name,'');
			Selected := Caption = FOpenName;
		end;
		FF.FindNext;
	end;
	FF.Free;

	if MultiMode then begin
		Button1.ModalResult := mrNone;
		Button1.Caption := 'ǉ';
		Button2.Caption := '';
	end else begin
		Button1.ModalResult := mrOk;
		Button1.Caption := 'OK';
		Button2.Caption := 'LZ';
	end;

	Result := ShowModal = mrOK;
	if Result or MultiMode then begin
		FOpenName := FOldLoaded;
		if not Assigned(FData) then FData := TTRPGCharactorData.Create;
		SetData(FData);
	end;
	ListView2SelectItem(Self,NIL,True);
end;

procedure TCharactorForm.FormDestroy(Sender: TObject);
begin
	FData.Free;
end;

function TCharactorForm.GetDataPath: TFileName;
begin
	Result := ExtractFilePath(Application.ExeName) + 'Settings\';
	if System <> '' then Result := Result + System + '\';
end;

procedure TCharactorForm.LineToList;
var LC: Integer;
begin
	ListView1.Items.BeginUpdate;
	ListView1.Items.Clear;
	for LC := RichEdit1.Lines.Count - 1 downto 0 do begin
		ValForm.Data.Line := RichEdit1.Lines[LC];
		if ValForm.Data.Name <> '' then LItoValForm(ListView1.Items.Insert(0))
		else RichEdit1.Lines.Delete(LC);
	end;
	ListView1.Items.EndUpdate;
end;

procedure TCharactorForm.ListView1DblClick(Sender: TObject);
begin
	A1.Click;
end;

procedure TCharactorForm.ListView2DblClick(Sender: TObject);
begin
	if not Assigned(ListView2.Selected) then A2.Click;
end;

procedure TCharactorForm.ListView2Edited(Sender: TObject; Item: TListItem;
  var S: string);
begin
	if FileExists(GetDataPath + S + '.txt') then begin
		S := Item.Caption;
		if S = '' then Item.Delete else PageControl1.Enabled := True;
	end else begin
		if S = '' then S := Item.Caption;
		//t@CύX
		if FileExists(GetDataPath + Item.Caption + '.txt') then begin
			if not RenameFile(GetDataPath + Item.Caption + '.txt',GetDataPath + S + '.txt') then begin
				S := Item.Caption;
			end;
		end;
		PageControl1.Enabled := True;
	end;
end;

procedure TCharactorForm.ListView2SelectItem(Sender: TObject; Item: TListItem;
	Selected: Boolean);
begin
	if Selected then begin
		if FOldLoaded <> '' then
			SaveFile(GetDataPath + FOldLoaded + '.txt');
		if Assigned(Item) then FOldLoaded := Item.Caption
		else FOldLoaded := '';

		if FOldLoaded <> '' then begin
			LoadFile(GetDataPath + FOldLoaded + '.txt');
			PageControl1.Enabled := True;
		end else begin
			PageControl1.Enabled := False;
		end;
	end else if Item.Caption = '' then Item.Delete
	else PageControl1.Enabled := False;
end;

procedure TCharactorForm.LoadFile(const FileName: String);
var
	C : TTRPGCharactorData;
begin
	C := TTRPGCharactorData.Create;
	if FileExists(FileName) then C.LoadFromFile(FileName) else begin
		C.Name := ListView2.Selected.Caption;
		C.HP_Name := Edit2.Text;
		C.MP_Name := Edit3.Text;
		C.FP_Name := Edit4.Text;
		C.FMP_Name := Edit5.Text;
	end;

	Edit1.Text := C.Name;
	Edit2.Text := C.HP_Name;
	Edit3.Text := C.MP_Name;
	Edit4.Text := C.FP_Name;
	Edit5.Text := C.FMP_Name;

	ComboBox1.ItemIndex := Ord(C.HP_Type);
	ComboBox2.ItemIndex := Ord(C.MP_Type);
	ComboBox3.ItemIndex := Ord(C.FP_Type);
	ComboBox4.ItemIndex := Ord(C.FMP_Type);

	DSE1.Value := C.HP_Now;
	DSE2.Value := C.MP_Now;
	DSE3.Value := C.FP_Now;
	DSE4.Value := C.FMP_Now;

	DSE5.Value := C.HP_Max;
	DSE6.Value := C.MP_Max;
	DSE7.Value := C.FP_Max;
	DSE8.Value := C.FMP_Max;

	Memo1.Text := C.Message.Text;
	RichEdit1.Text := C.Values.Text;
	LineToList;
	SetValueList;
	C.Free;
end;

procedure TCharactorForm.N2Click(Sender: TObject);
begin
	if Assigned(ListView2.Selected) then
		ListView2.Selected.EditCaption;
end;

procedure TCharactorForm.OrderChange(const ID: Integer; const DestA, DestB,
	DestC: TControl);
begin
	DestA.Visible := ID <= 1;
	DestB.Visible := ID = 0;
	DestC.Visible := ID = 0;
end;

procedure TCharactorForm.PageControl1Change(Sender: TObject);
begin
	if (PageControl1.ActivePageIndex = 0) then begin
		if RichEdit1.Visible then LineToList;
		SetValueList;
	end;
end;

procedure TCharactorForm.SaveFile(const FileName: String);
var
	C : TTRPGCharactorData;
begin
	C := TTRPGCharactorData.Create;
	SetData(C);
	C.SaveToFile(FileName);
	C.Free;
end;

procedure TCharactorForm.SetData(const C: TTRPGCharactorData);
begin
	C.Name := Edit1.Text;

	C.HP_Name := Edit2.Text;
	C.MP_Name := Edit3.Text;
	C.FP_Name := Edit4.Text;
	C.FMP_Name := Edit5.Text;

	C.HP_Type := TTRPGParamCodes(ComboBox1.ItemIndex);
	C.MP_Type := TTRPGParamCodes(ComboBox2.ItemIndex);
	C.FP_Type := TTRPGParamCodes(ComboBox3.ItemIndex);
	C.FMP_Type := TTRPGParamCodes(ComboBox4.ItemIndex);

	C.HP_Now := DSE1.Value;
	C.MP_Now := DSE2.Value;
	C.FP_Now := DSE3.Value;
	C.FMP_Now := DSE4.Value;

	C.HP_Max := DSE5.Value;
	C.MP_Max := DSE6.Value;
	C.FP_Max := DSE7.Value;
	C.FMP_Max := DSE8.Value;

	C.Message.Text := Memo1.Text;
	C.Values.Text := RichEdit1.Text;
end;

procedure TCharactorForm.SetValueList;
var LC : Integer;
begin
		ComboBox5.Items.BeginUpdate;
	ComboBox5.Items.Clear;
	for LC := 0 to ListView1.Items.Count - 1 do begin
		ComboBox5.Items.Add(ListView1.Items[LC].Caption);
	end;
	if ComboBox5.ItemIndex < 0 then ComboBox5.ItemIndex := 0;
	ComboBox5.Items.EndUpdate;
end;

procedure TCharactorForm.TabControl1Change(Sender: TObject);
begin
	RichEdit1.Visible := TabControl1.TabIndex = 1;
	ListView1.Visible := TabControl1.TabIndex = 0;
	if TabControl1.TabIndex = 0 then LineToList;
end;

end.
